﻿///////////////////////////////////////////////////////////////////////////////////////////////////
//                 Ermittlung Verlsutleistung
///////////////////////////////////////////////////////////////////////////////////////////////////
// Erstellt am:     2015-014-08 
// Erstellt von:    jn
// Geändert am:     -
// Geändert von:    -
// Änderung:		- 
///////////////////////////////////////////////////////////////////////////////////////////////////

using System.IO;
using System.Diagnostics;

public class Verlustleistung
{
	[DeclareAction("Verlustleistung")]
	public void MyVoid()
	{   
		// < Allgemeine Daten: Anfang >
        // Projektdatei, Projektpfad, Projektname
        string sSelectedProjectData = string.Empty;		// kompletter Pfad + Projektdateinamen + Erweiterung
		string sSelectedProjectPath = string.Empty;		// Projektpfad
        string sSelectedProjectName = string.Empty;		// Projektname
		string sKommission = string.Empty;				// Kommission
		
        // Projektdatei komplett
        CommandLineInterpreter oCLI = new CommandLineInterpreter();
        Eplan.EplApi.ApplicationFramework.ActionCallingContext ctx = new Eplan.EplApi.ApplicationFramework.ActionCallingContext();
        ctx.AddParameter("TYPE", "PROJECT");

        bool bRet = oCLI.Execute("selectionset", ctx); // Action: Projektpfad 
        if (bRet == true)
        {
            ctx.GetParameter("PROJECT", ref sSelectedProjectData);
        }

        // Projektpfad
        sSelectedProjectPath = System.IO.Path.GetDirectoryName(sSelectedProjectData);

        // Projektname
        sSelectedProjectName = System.IO.Path.GetFileNameWithoutExtension(sSelectedProjectData);
		
		// Kommission	
		sKommission = sSelectedProjectPath.Substring(sSelectedProjectPath.LastIndexOf('\\')+1);
		//MessageBox.Show(sKommission);

		// Im Seitennavigator markierten Bereich auslesen
		string sPages = string.Empty;
		ActionCallingContext oCTX1 = new ActionCallingContext();
		CommandLineInterpreter oCLI1 = new CommandLineInterpreter();
		oCTX1.AddParameter("TYPE", "PAGES");
		oCLI1.Execute("selectionset", oCTX1);
		oCTX1.GetParameter("PAGES", ref sPages);
		string[] sarrPages = sPages.Split(';');
		string sPageName = sarrPages[0];

		// ensure unique level codes:
		// Funktionale Zuordnung -> $
		// Aufstellungsort -> %
		sPageName = sPageName.Replace("==", "$").Replace("++", "%");
		// get location from pagename
		string sAnlage = ExtractLevelName(sPageName, "=");
		string sEinbauort = ExtractLevelName(sPageName, "+");
		//MessageBox.Show(String.Format("Seitenname: {0}\nAnlage: {1}\nEinbauort: {2}", sPageName, sAnlage, sEinbauort));

		
		
		// Daten Aufbereitung
		string sSubstitutePath = @sSelectedProjectPath + @"\" + sSelectedProjectName + @".edb\DOC\Verlustleistung\";				// Speicherort
		string sFilename = sKommission + @"_" + @"=" + sAnlage + @"+" + sEinbauort + @"_10.10_Ermittlung Verlustleistung.xlsx";		// Dateiname
		string sDestFile = sSubstitutePath + sFilename;																				// Zieldatei
		string sPost = @"Script_Verlustleistung";																					// Beschriftungsschema	
        // < Allgemeine Daten: Ende >	
		
		// Bugfix 1.9.10
        oCLI.Execute("EsGenerateConnections");
		
	    // Abfrage: YES/NO
        DialogResult oDialogResult = new DialogResult();
        oDialogResult = MessageBox.Show("Soll die Verlustleistung für den markierten Bereich in\n \n=" + sAnlage + "+" + sEinbauort +   "\n \nermittelt werden?", "Ermittlung Verlustleistung [" + sSelectedProjectName + "]", MessageBoxButtons.YesNo);
		//oDialogResult = MessageBox.Show("Sollen die Daten fuer das Messprotokoll erzeugt werden?", "Messprotokoll [" + sSelectedProjectName + "]", MessageBoxButtons.YesNo);
		
        if (oDialogResult == DialogResult.Yes)
				
		{	
			// Verzeichnis erzeugen
			Directory.CreateDirectory(sSubstitutePath);
			
			// Dialog "Speichern unter"
			SaveFileDialog sfd = new SaveFileDialog();
			sfd.DefaultExt = "xlsx";
			sfd.FileName = sFilename;
			sfd.Filter = "Exceldatei (*.xlsx)|*.xlsx";
			sfd.InitialDirectory = sSubstitutePath;
			sfd.Title = "Speichern unter";
			sfd.ValidateNames = true;

			if (sfd.ShowDialog() == DialogResult.OK)
			{
				{
					// Beschriftung
					Progress progress = new Progress("SimpleProgress");
					progress.SetTitle("Datei wird erzeugt...");
					progress.SetActionText(sDestFile + " wird erzeugt...");
					progress.ShowImmediately();
					progress.BeginPart(100,"");
					progress.SetAllowCancel(true);
					if(!progress.Canceled())
					{
						progress.BeginPart(100,"Verlustleistung");
						ActionCallingContext labellingContext = new ActionCallingContext ();
						
						labellingContext.AddParameter("USESELECTION","1");						// Nur der selektierte Bereich wird ausgewertet
						labellingContext.AddParameter("CONFIGSCHEME", sPost);					// Beschriftungsschema
						labellingContext.AddParameter("DESTINATIONFILE", sfd.FileName); 		// Zieldatei	
						labellingContext.AddParameter("FILTERSCHEME","");
						labellingContext.AddParameter("LANGUAGE","de_DE");
						labellingContext.AddParameter("LogMsgActionDone","true");
						labellingContext.AddParameter("SHOWOUTPUT","1");
						labellingContext.AddParameter("RECREPEAT","1");
						labellingContext.AddParameter("SORTSCHEME","");
						labellingContext.AddParameter("TASKREPEAT","1");
						new CommandLineInterpreter().Execute("label",labellingContext);
						progress.EndPart();
					}
						
					MessageBox.Show(
						"Datei wurde erfolgreich gespeichert:\n" + sfd.FileName,
						"Information",
						MessageBoxButtons.OK,
						MessageBoxIcon.Information
						);
				
					progress.EndPart(true);
				}
			}	
		} 
	}


		
	// Im Seitennavigator markierten Bereich auslesen
	private string ExtractLevelName(string sPage, string sLevel)
	{
		string sLevelName = string.Empty;

		if (sPage.Contains(sLevel))
		{
			//check existing level codes (remove all text of following level code)
			#region Funktionale Zuordnung
			if (sLevel == "$")
			{
				if (sPage.Contains("="))
				{
					sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("=") - sPage.IndexOf(sLevel));
					goto DONE;
				}
				if (sPage.Contains("%"))
				{
					sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("%") - sPage.IndexOf(sLevel));
					goto DONE;
				}
				if (sPage.Contains("+"))
				{
					sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("+") - sPage.IndexOf(sLevel));
					goto DONE;
				}
				if (sPage.Contains("&"))
				{
					//check if document type is at beginning
					if (sPage.StartsWith("&"))
					{
						//no extracting needed, when document type at beginning						
					}
					else
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("&") - sPage.IndexOf(sLevel));
						goto DONE;
					}
				}
				if (sPage.Contains("#"))
				{
					//check if user-defined is at beginning
					if (sPage.StartsWith("#"))
					{
						//no extracting needed, when user-defined at beginning
					}
					else
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("#") - sPage.IndexOf(sLevel));
						goto DONE;
					}
				}
				//no further structure identifier existing
				sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("/") - sPage.IndexOf(sLevel));
			}
			#endregion

			#region Anlage
			if (sLevel == "=")
			{
				if (sPage.Contains("%"))
				{
					sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("%") - sPage.IndexOf(sLevel));
					goto DONE;
				}
				if (sPage.Contains("+"))
				{
					sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("+") - sPage.IndexOf(sLevel));
					goto DONE;
				}
				if (sPage.Contains("&"))
				{
					//check if document type is at beginning
					if (sPage.StartsWith("&"))
					{
						//no extracting needed, when document type at beginning						
					}
					else
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("&") - sPage.IndexOf(sLevel));
						goto DONE;
					}
				}
				if (sPage.Contains("#"))
				{
					//check if user-defined is at beginning
					if (sPage.StartsWith("#"))
					{
						//no extracting needed, when user-defined at beginning
					}
					else
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("#") - sPage.IndexOf(sLevel));
						goto DONE;
					}
				}

				//no further structure identifier existing
				sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("/") - sPage.IndexOf(sLevel));
			}
			#endregion

			#region Aufstellungsort
			if (sLevel == "%")
			{
				if (sPage.Contains("+"))
				{
					sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("+") - sPage.IndexOf(sLevel));
					goto DONE;
				}
				if (sPage.Contains("&"))
				{
					//check if document type is at beginning
					if (sPage.StartsWith("&"))
					{
						//no extracting needed, when document type at beginning						
					}
					else
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("&") - sPage.IndexOf(sLevel));
						goto DONE;
					}
				}
				if (sPage.Contains("#"))
				{
					//check if user-defined is at beginning
					if (sPage.StartsWith("#"))
					{
						//no extracting needed, when user-defined at beginning
					}
					else
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("#") - sPage.IndexOf(sLevel));
						goto DONE;
					}
				}

				//no further structure identifier existing
				sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("/") - sPage.IndexOf(sLevel));
			}
			#endregion

			#region Einbauort
			if (sLevel == "+")
			{
				if (sPage.Contains("&"))
				{
					//check if document type is at beginning
					if (sPage.StartsWith("&"))
					{
						//no extracting needed, when document type at beginning						
					}
					else
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("&") - sPage.IndexOf(sLevel));
						goto DONE;
					}
				}

				if (sPage.Contains("#"))
				{
					//check if user-defined is at beginning
					if (sPage.StartsWith("#"))
					{
						//no extracting needed, when user-defined at beginning
					}
					else
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("#") - sPage.IndexOf(sLevel));
						goto DONE;
					}
				}

				//no further structure identifier existing
				sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("/") - sPage.IndexOf(sLevel));
			}
			#endregion

			#region Dokumentenart
			if (sLevel == "&")
			{
				//check if document type is at beginning
				if (sPage.StartsWith("&"))
				{
					//check further existing structures						
					if (sPage.Contains("$"))
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("$") - sPage.IndexOf(sLevel));
						goto DONE;
					}
					if (sPage.Contains("="))
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("=") - sPage.IndexOf(sLevel));
						goto DONE;
					}
					if (sPage.Contains("%"))
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("%") - sPage.IndexOf(sLevel));
						goto DONE;
					}
					if (sPage.Contains("+"))
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("+") - sPage.IndexOf(sLevel));
						goto DONE;
					}
					if (sPage.Contains("#"))
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("#") - sPage.IndexOf(sLevel));
						goto DONE;
					}

					//no further structure identifier existing
					sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("/") - sPage.IndexOf(sLevel));
					goto DONE;
				}
				else
				{
					//document typ NOT at beginning
					if (sPage.Contains("#"))
					{
						if (sPage.StartsWith("#"))
						{
							//no extracting needed, when user-defined at beginning
						}
						else
						{
							sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("#") - sPage.IndexOf(sLevel));
							goto DONE;
						}
					}

					//no further structure identifier existing
					sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("/") - sPage.IndexOf(sLevel));
				}

			}
			#endregion

			#region Benutzerdefiniert
			if (sLevel == "#")
			{
				//check if user defined is at beginning
				if (sPage.StartsWith("#"))
				{
					//check further existing structures						
					if (sPage.Contains("$"))
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("$") - sPage.IndexOf(sLevel));
						goto DONE;
					}
					if (sPage.Contains("="))
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("=") - sPage.IndexOf(sLevel));
						goto DONE;
					}
					if (sPage.Contains("%"))
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("%") - sPage.IndexOf(sLevel));
						goto DONE;
					}
					if (sPage.Contains("+"))
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("+") - sPage.IndexOf(sLevel));
						goto DONE;
					}
					if (sPage.Contains("&"))
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("&") - sPage.IndexOf(sLevel));
						goto DONE;
					}

					//no further structure identifier existing
					sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("/") - sPage.IndexOf(sLevel));
					goto DONE;
				}
				else
				{
					//document typ NOT at beginning
					if (sPage.Contains("#"))
					{
						sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("/") - sPage.IndexOf(sLevel));
						goto DONE;
					}
				}
			}
			#endregion
		}
	DONE:
		//remove page no		
		if (sLevelName == string.Empty && sPage.Contains(sLevel))
		{
			sLevelName = sPage.Substring(sPage.IndexOf(sLevel), sPage.IndexOf("/") - sPage.IndexOf(sLevel));
		}

		if (sLevelName != string.Empty)
		{
			sLevelName = sLevelName.Replace(sLevel, string.Empty);
		}

		return sLevelName;
	}

}